<template>
  <div class="row justify-content-center">
    <div class="col-md-12">
      <div class="card">
        <div class="card-header d-flex justify-content-between">
          <h5 class="card-title">Usuarios</h5>
          <button
            @click="manageView(false)"
            class="btn btn-success"
            data-toggle="modal"
            data-target=".user-modal-xl"
          >Crear nuevo usuario</button>
        </div>
        <div class="card-body">
          <table class="table table-striped table-dark">
            <thead>
              <tr>
                <th scope="col">#</th>
                <th scope="col">Nombre</th>
                <th scope="col">Email</th>
                <th scope="col">Fecha de creación</th>
                <th scope="col">Acciones</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="user in data" :key="user.id">
                <th scope="row" v-text="user.id"></th>
                <td v-text="user.name"></td>
                <td v-text="user.email"></td>
                <td v-text="user.created_at"></td>
                <td>
                  <div class="btn-group" role="group">
                    <button
                      id="btnGroupDrop1"
                      type="button"
                      class="btn btn-secondary dropdown-toggle"
                      data-toggle="dropdown"
                      aria-haspopup="true"
                      aria-expanded="false"
                    >Acciones</button>
                    <div class="dropdown-menu" aria-labelledby="btnGroupDrop1">
                      <a class="dropdown-item" href="#">Ver</a>
                      <a
                        @click.prevent="manageView(user,true)"
                        class="dropdown-item"
                        data-toggle="modal"
                        data-target=".user-modal-xl"
                        href="#"
                      >Editar</a>
                      <a class="dropdown-item" href="#">Eliminar</a>
                    </div>
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        <div class="card-footer">algo va aqui</div>
      </div>
    </div>

    <div
      class="modal fade user-modal-xl"
      tabindex="-1"
      role="dialog"
      aria-labelledby="myExtraLargeModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Crear un nuevo usuario</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <form>
              <div class="form-group">
                <label for="name" class="col-form-label">Nombre de usuario</label>
                <input type="text" class="form-control" id="name" v-model="name" />
              </div>
              <div class="form-group">
                <label for="email" class="col-form-label">Correo electrónico:</label>
                <input type="email" class="form-control" id="email" v-model="email" />
              </div>
              <div class="form-group">
                <label for="password" class="col-form-label">Contraseña:</label>
                <input type="password" class="form-control" id="password" v-model="password" />
              </div>
              <div class="form-group">
                <label for="password_confirmation" class="col-form-label">Repita su contraseña:</label>
                <input
                  type="password"
                  class="form-control"
                  id="password_confirmation"
                  v-model="password_confirmation"
                />
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
            <input @click="store()" type="submit" class="btn btn-success" id="saveBtn" />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      name: "",
      email: "",
      password: "",
      password_confirmation: "",
      data: []
    };
  },
  mounted() {
    this.getUsers();

    Echo.channel("realtime_database_users-channel").listen(
      ".user.created",
      response => {
        let user = response.user;
        let html = `
                    <tr>
                        <th scope="row">${user.id}</th>
                        <td>${user.name}</td>
                        <td>${user.email}</td>
                        <td>${user.created_at}</td>
                        <td>
                            <div class="btn-group" role="group">
                                <button
                                id="btnGroupDrop1"
                                type="button"
                                class="btn btn-secondary dropdown-toggle"
                                data-toggle="dropdown"
                                aria-haspopup="true"
                                aria-expanded="false"
                                >Acciones</button>
                                <div class="dropdown-menu" aria-labelledby="btnGroupDrop1">
                                    <a class="dropdown-item" href="#">Ver</a>
                                    <a class="dropdown-item" href="#">Editar</a>
                                    <a class="dropdown-item" href="#">Eliminar</a>
                                </div>
                            </div>
                        </td>
                    </tr>                    
                `;

        $(html)
          .hide()
          .prependTo("tbody")
          .fadeIn();
      }
    );
  },

  methods: {
    getUsers() {
      axios
        .get("/api/v1/users")
        .then(response => {
          this.data = response.data.users.data;
        })
        .catch(error => {
          console.log(error);
        });
    },
    store() {
      $("#saveBtn").val("Guardando ...");
      $("#saveBtn").attr("disabled", true);

      let me = this;

      axios
        .post("/api/v1/users", {
          name: this.name,
          email: this.email,
          password: this.password,
          password_confirmation: this.password_confirmation
        })
        .then(response => {
          console.log(response);
          me.clearFields();
          $(".user-modal-xl").modal("hide");
        })
        .catch(error => {
          console.log(error);
        });
    },
    update(user) {
      axios
        .put(`/api/v1/users/${user.id}`, {
          name: this.name,
          email: this.email,
          password: this.password,
          password_confirmation: this.password_confirmation
        })
        .then(response => {
          $("#saveBtn").val("Guardando ...");
          $("#saveBtn").attr("disabled", true);
          $(".create-user-modal-xl").modal("hide");
          console.log(response);
        })
        .catch(error => {
          console.log(error);
        });
    },
    manageView(user = null,mode) {
      $("#saveBtn").attr("disabled", false);
      if (mode) {
        $("#name").val(user.name);
        $("#email").val(user.email);
        $("#saveBtn").val("Actualizar usuario");
      } else {
        $("#saveBtn").val("Guardar usuario");
      }
    },
    clearFields() {
      this.name = "";
      this.email = "";
      this.password = "";
      this.password_confirmation = "";
    }
  }
};
</script>